// URLLDCLS This class is copyright (c) by methodica herger & krasznai
//          Address:   Fellstr. 3, P.O. Box 39, CH-5413 Switzerland
//          Internet:  http://www.methodica.ch, mail@methodica.ch
//
//          Purpose:
//
//
//
//          This code is freeware.
//          You are free to use and modify it, as long as due credit is
//          given, and the resulting source code is made available to the
//          public too.
//          If you use this code, drop us a line ("mailATmethodica.ch"), so
//          that we know, how many people are using it, and what an impact
//          modifications to it will have.
//
//          The code is given to the public domain on an "as is" basis.
//          This means, that neither the author, nor methodica can be made
//          responsible under any circumstances for damages caused by this
//          applet or malfunctions of this applet. Since the source codue
//          is published, you might convince yourself of the fact, that the
//          applet contains no offending or destructive code.
//
//          1998-06-09, Hans E. Herger <hans.herger@methodica.ch>

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Hashtable;
import java.net.URL;
import java.net.URLConnection;
import java.net.MalformedURLException;
import java.net.UnknownServiceException;
import java.lang.ClassFormatError;
import java.lang.System;


public class urlldcls extends java.lang.ClassLoader
{
    Hashtable   m_cache = new Hashtable();
    URL         m_URL;
    
    public urlldcls(URL baseURL, String name)
    {
        m_URL = prepURL(baseURL, name);
    }

    protected URL prepURL(URL baseURL, String name)
    {
        if (name == null) return null;
        try
        {
            if (baseURL == null)
            {   return new URL(name); }
            else
            {   return new URL(baseURL, name); }
        }
        catch (MalformedURLException e)  
        {
            return null;
        }
    } // end of method prepURL

    private byte loadClassData(URLConnection uc)[]
    {   
        if (uc == null) return null;

        InputStream is;
        String msg;
        try
        {
            is = uc.getURL().openStream();
        }
        catch (IOException ioe1)
        {
            return null;
        }
        byte data[] = null;
        byte dt[] = null;
        int xt = 0;
        int xo = 0;
        int xi = 2048;
        while (xi >= 2048)
        {
            try
            {   dt = new byte[xo+xi];
                if (xo > 0)
                {
                    System.arraycopy(data, 0, dt, 0, xo);
                }
                data = dt;
                xi = is.read(data, xo, xi);
                xo += xi;
            }
            catch (IOException ioe2)
            {
                return null;
            }
        }
        if ((xo % 2048) != 0)
        {
            data = new byte[xo];
            System.arraycopy(dt, 0, data, 0, xo);
            return data;
        }
        return dt;
    } // end of method loadClassData

    protected Class ldC(String name, boolean resolve)
    {
        Class c = null;
        Object o;
        if (m_URL==null) return c;
        o = m_cache.get(name);
        if (o != null)
        {
            c = o.getClass();
        }
        if (c == null)
        {
            try
            {
                URLConnection uc = m_URL.openConnection();
                if (uc != null)
                {
                    byte cdata[] = loadClassData(uc);
                    if (cdata.length < 1) return null;
                    try
                    {
                        c = defineClass(cdata, 0, cdata.length);
                    }
                    catch (ClassFormatError cfe1)
                    {
                        c = null;
                    }
                    if (c!=null) m_cache.put(name, c);
                }
                else {  c = null; }
            }
            catch (IOException ioe1)
            {
                c = null;
            }
        }
        if ((resolve) && (c != null))
        {
            resolveClass(c);
        }
        return c;
    }

    public synchronized Class loadClass(String name, boolean resolve)
    {
        try     
        { 
            return findSystemClass(name);
        }
        catch   (ClassNotFoundException cnfe1) 
        {
            return ldC(name, resolve);
        }
        catch   (NoClassDefFoundError ncde1) {}
        return null;
    }

} // end of class ldclass